diff -purN u-boot-0.4.6/common/cmd_nand.c u-boot-0.4.6-1/common/cmd_nand.c
--- u-boot-0.4.6/common/cmd_nand.c	Sat Jul 26 19:21:15 2003
+++ u-boot-0.4.6-1/common/cmd_nand.c	Mon Aug 18 09:26:15 2003
@@ -1212,6 +1212,9 @@ static int nand_write_oob(struct nand_ch
 	       buf[8], buf[9], buf[14],buf[15]);
 #endif
 
+#ifdef CONFIG_OMAP1510
+	archflashwp(0,0);
+#endif
 	NAND_ENABLE_CE(nand);  /* set pin low to enable chip */
 
 	/* Reset the chip */
@@ -1255,6 +1258,9 @@ static int nand_write_oob(struct nand_ch
 			puts ("Error programming oob data\n");
 			/* There was an error */
 			NAND_DISABLE_CE(nand);  /* set pin high */
+#ifdef CONFIG_OMAP1510
+			archflashwp(0,1);
+#endif
 			*retlen = 0;
 			return -1;
 		}
@@ -1278,11 +1284,17 @@ static int nand_write_oob(struct nand_ch
 		puts ("Error programming oob data\n");
 		/* There was an error */
 		NAND_DISABLE_CE(nand);  /* set pin high */
+#ifdef CONFIG_OMAP1510
+		archflashwp(0,1);
+#endif
 		*retlen = 0;
 		return -1;
 	}
 
 	NAND_DISABLE_CE(nand);  /* set pin high */
+#ifdef CONFIG_OMAP1510
+	archflashwp(0,1)
+#endif
 	*retlen = len;
 	return 0;
 
